
#include <windows.h>
#include <stdio.h>
#include <conio.h>

#include "isdll.h"

//=********************** main ****************************
//=********************************************************
int   main(int argc, char *argv[] )
{
	HANDLE		handle;
	ULONG		blockSize=0x1000;
	ULONG		*ptr;
	ULONG64	phAddr;

	//int			loop, ii;

	// Parse Command Line
	if( argc<2 )
	{
		printf("\nUsage: ISALLOC <block size>\n\n" );
		return 1;
	}
	char* endptr;
	blockSize = strtoul(argv[1], &endptr, 16);
	//sscanf( argv[1], "%x", &blockSize );

	// Open UNINSYS Driver
	handle = UniDrv_Open(0);
	if( handle==0 )
	{
		printf("ISALLOC ERROR: Can't Open ISDRV\n\n" );
		return 1;
	}

	// Main Loop
	//for( loop=0; ;loop++ )
	{
		//
		// Alloc Buffer
		//
		if( 0>UniDrv_Mem_Alloc( handle, blockSize, &phAddr, &ptr ) )
		{
			printf( "ISALLOC ERROR: Bad UniDrv_Mem_Alloc() execution\n\n" );
			//break;
		}
		else
		{
			//printf( "%5d/ size=0x%X phAddr=0x%X linAddr=0x%X\n", loop, blockSize, phAddr, ptr );
			printf( " size=0x%X phAddr=0x%I64X linAddr=0x%X\n", blockSize, phAddr, ptr );

			//
			// Free Buffer
			//
			Sleep( 10 );
			if( 0>UniDrv_Mem_Free( handle, ptr ) )
			{
				printf( "ISALLOC ERROR: Bad UniDrv_Mem_Free() execution\n\n" );
				//break;
			}
		}
		//
		// Complete if pressed <ESC>
		//
		//if( _kbhit() ) if( 0x1B == _getch()) break;
	}

	// Close UNINSYS Driver
	UniDrv_Close(handle);
	return 0;
}


//
// End of File
//
